#include <stdio.h>
#include "npc.h"

struct formula *read_formula()
	{
	char input;
	long accepted;
	struct formula *result, *curr_f, *place;
	result=place=NULL;
	for(accepted=FALSE; ((!(accepted==TRUE)) || (input==EOF));)
		{
		input=getchar();
                if ((input == '(') ||
                    (input == ')') ||
                    (input == '!') ||
                    (input == '^') ||
                    ((input >= '0') &&
                    (input <= '9')))
                        {
                        curr_f = (struct formula *)
                                malloc(sizeof(struct formula));
                        curr_f->character=input;
                        curr_f->next=NULL;
			result=place=curr_f;
			accepted=TRUE;
                        }
		}
	if (!(input==EOF))
		for(input=getchar();(!(input==EOF));input=getchar())
			{
			if ((input == '(') ||
		    	(input == ')') ||
		    	(input == '!') ||
		    	(input == '^') ||
		    	((input >= '0') &&
		    	(input <= '9')))
				{
				curr_f = (struct formula *)
					malloc(sizeof(struct formula));
				curr_f->character=input;
				curr_f->next=NULL;
				place->next=curr_f;
				place=curr_f;
				}
		}
	return result;
	}

void append(struct formula *f, char c)
	{
	struct formula *curr_f, *new_f;
	for(curr_f=f;(!(curr_f->next==NULL));curr_f=curr_f->next);
	new_f=(struct formula *) malloc(sizeof(struct formula));
	new_f->character=c;
	new_f->next=NULL;
	curr_f->next=new_f;
	}

long calc_index(struct formula *f)
	{
	struct formula *curr_f;
	long value;
	value=0;
	if (!(f==NULL))
		for(curr_f=f;(!(curr_f==NULL));curr_f=curr_f->next)
			value= ((value*10) + (curr_f->character - '0'));
	return value;
	}

void free_formula(struct formula *f)
	{
	if (!(f->next==NULL))
		free_formula(f->next);
	free(f);
	}

void free_set(struct set *s)
	{
	if (!(s->true==NULL))
		free_set(s->true);
	if (!(s->false==NULL))
		free_set(s->false);
	free(s);
	}

long empty(struct set *s)
	{
	long result;
	if (s==NULL) /* A null pointer references the whole set. */
		result=FALSE;
	else
		result= (!((s->flags & SATISFY_TRUE) || (s->flags & SATISFY_FALSE)));
	return result;
	}

void output(struct set *s)
	{
	if (s==NULL)
		printf("Any assignment of variables not specified.\n\n");
	else
		{
		if (!((s->flags & SATISFY_TRUE) || (s->flags & SATISFY_FALSE)))
			printf("No assignment of variable %d will satisfy the formula.\n", s->index);
		else
			{
			if (s->flags & SATISFY_TRUE)
				{
				printf("For variable %d true:\n\n",s->index);
				output(s->true);
				printf("End of satisfying assignments for variable %d true.\n\n", s->index);
				}
			if (s->flags & SATISFY_FALSE)
				{
				printf("For variable %d false:\n\n",s->index);
				output(s->false);
				printf("End of satisfying assignments for variable %d false.\n\n", s->index);
				}
			}
		}
	}

void output_f(struct formula *f)
	{
	struct formula *curr_f;
	for(curr_f=f;(!(curr_f==NULL));curr_f=curr_f->next)
		printf("%c",curr_f->character);
	printf("\n");
	}

long is_digit(char c)
	{
	return ((c >= '0') && (c <= '9'));
	}
